<?php

namespace Teknisa\SM\Service;

use Doctrine\ORM\EntityManager;
use Teknisa\SM\Factory\Sm00006000ElementoFactory as ElementoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\SM\Util\Procedure\FctUpdateNomeProdutoOm;

class Sm00006000ElementoService {
    
    protected $elementoFactory;
    protected $environment;
    
    public function __construct(ElementoFactory $elementoFactory, environment $environment, EntityManager $entityManager) {
        $this->elementoFactory = $elementoFactory;
        $this->environment  = $environment;
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Exclui o elemento e seus filhos.
     * 
     * @param integer $nritcompservico
     * @param integer $nrorg
     */
    public function excluirElementoEmCascata($idelemento, $nrorg) {
        $params = array(
            "IDELEMENTO" => $idelemento,
            "NRORG"      => $nrorg
        );
        
        $this->elementoFactory->excluirElementoEmCascata($params);
    }
    
    /**
     * 
     */
    public function salvarMedidaVariavelEmCascata($cdtpmedidavariavel, $idelemento, $nrorg, $cdCentCust) {
        $params = array(
            "CDTPMEDIDAVARIAVEL"    => $cdtpmedidavariavel,
            "IDELEMENTO"            => $idelemento,
            "NRORG"                 => $nrorg,
            "CDCENTCUST"            => $cdCentCust
        );
        
        $this->elementoFactory->salvarMedidaVariavelEmCascata($params);
    }
    
    
     /**
     *  A função "validaIdentificador"  Realiza a validação  do campo "identificador". 
     *  Não podem haver dois identificadores.
     */
     
     public function validaIdentificador($idItemCalculo){
    
        $params = array(
            "IDITEMCALCULO"      => $idItemCalculo,
            "NRORG"              => $this->environment->getNrOrg()
        );
        
        $valIdentificador = $this->elementoFactory->validaIdentificador($params);
        
        return $valIdentificador[0];
    }
    
    public function updateNomeOm($idElemento, $nmServOrca){
        $procedure = new FctUpdateNomeProdutoOm($this->connection);
        
        $procedure->executar($idElemento, $nmServOrca);
    }
}

?>